'-----------------------------------------------------------------
' CCTools IC-Bus-Routinen fr C-Control Mikro zum PCFLCD-Interface
' CCTools 2004 (http://cctools.hs-control.de)
'-----------------------------------------------------------------
' Die hufigsten IC-Bus-Adressen:
' &h20 - &h2E    MAX7311 16Bit Portexpander
' &h30 - &h3E    MAX7311 16Bit Portexpander
' &h40 - &h4E    MAX7311 16Bit Portexpander
' &h40 - &h4E    PCF8574 Portexpander
' &h50 - &h5E    MAX7311 16Bit Portexpander
' &h50 - &h5E    MAX520 4ch. 8Bit DA-Wandler
' &h68 - &h6E    MAX4572 Analog-Schalter (write only)
' &h70 - &h7E    PCF8574A Portexpander
' &h90 - &h9E    PCF8591 4ch. 8Bit AD-Wandler
' &h90 - &h9E    DS1631 12Bit Temperatursensor
' &hA0 - &hA2    PCF8583 Uhrenbaustein
' &hA0 - &hA6    serielle EEProms 24C128 - 24C512
' &hA0 - &hAE    serielle EEProms 24C01 - 24C64
' &hA0 - &hAE    MAX7311 16Bit Portexpander
' &hB0 - &hBE    MAX7311 16Bit Portexpander
' &hC0 - &hCE    MAX7311 16Bit Portexpander
' &hD0 - &hDE    MAX7311 16Bit Portexpander
'-----------------------------------------------------------------
' Speicherbedarf der IC-Bus-Routinen: 156 Byte
'-----------------------------------------------------------------
define SCL PORT[5] ' Pull-Up mit 4,7k bis 10k notwendig
define SDA PORT[6] ' Pull-Up mit 4,7k bis 10k notwendig


define i byte[1] 'temporres Byte
define data byte[2] 'Byte zur Datenbergabe zu/von IC-Bus-Routinen
define databit3 bit[12]
define LCDData byte[3]
define j byte[4] 'temporres Byte
define zahl byte[4] 'temporres Byte
define LCDlight bit[192]' Bit-Var fr LCD-Beleuchtung

'ASCII
Define A_ &H41 : Define B_ &H42 : Define C_ &H43 : Define D_ &H44 : Define E_ &H45
Define F_ &H46 : Define G_ &H47 : Define H_ &H48 : Define I_ &H49 : Define J_ &H4A
Define K_ &H4B : Define L_ &H4C : Define M_ &H4D : Define N_ &H4E : Define O_ &H4F
Define P_ &H50 : Define Q_ &H51 : Define R_ &H52 : Define S_ &H53 : Define T_ &H54
Define U_ &H55 : Define V_ &H56 : Define W_ &H57 : Define X_ &H58 : Define Y_ &H59 : Define Z_ &H5A
Define ak &H61 : Define bk &H62 : Define ck &H63 : Define dk &H64 : Define ek &H65
Define fk &H66 : Define gk &H67 : Define hk &H68 : Define ik &H69 : Define jk &H6A
Define kk &H6B : Define lk &H6C : Define mk &H6D : Define nk &H6E : Define ok &H6F
Define pk &H70 : Define qk &H71 : Define rk &H72 : Define sk &H73 : Define tk &H74
Define uk &H75 : Define vk &H76 : Define wk &H77 : Define xk &H78 : Define yk &H79 : Define zk &H7A
Define SPACE &H20 : Define MINUS &H2D : Define GLEICH &H3D : Define DPP &H3A
Define Dot &H2E
Define Line1 &H80 : Define Line2 &HC0 : Define Line3 &H94 : Define Line4 &HD4 'Fr 4x20 LCD
'Define Line1 &H80 : Define Line2 &HC0 : Define Line3 &H90 : Define Line4 &HD0 'Fr 4x16 LCD


define PCFLCD &h40 'PCFLCD an PCF8574 ohne A an 0.0.0

baud 9600

gosub i2c_stop ' "Initialisierung" des IC-Busses

 gosub PCFLCD_init
 LCDData = T_ : gosub PCFLCD_Put
 LCDData = ek : gosub PCFLCD_Put
 LCDData = sk : gosub PCFLCD_Put
 LCDData = tk : gosub PCFLCD_Put

 LCDData = Line2 : gosub PCFLCD_CMD
 LCDData = C_ : gosub PCFLCD_Put
 LCDData = C_ : gosub PCFLCD_Put
 LCDData = T_ : gosub PCFLCD_Put
 LCDData = ok : gosub PCFLCD_Put
 LCDData = ok : gosub PCFLCD_Put
 LCDData = lk : gosub PCFLCD_Put
 LCDData = sk : gosub PCFLCD_Put
 LCDData = SPACE : gosub PCFLCD_Put
 LCDData = MINUS : gosub PCFLCD_Put
 LCDData = SPACE : gosub PCFLCD_Put
 LCDData = P_ : gosub PCFLCD_Put
 LCDData = C_ : gosub PCFLCD_Put
 LCDData = F_ : gosub PCFLCD_Put
 LCDData = L_ : gosub PCFLCD_Put
 LCDData = C_ : gosub PCFLCD_Put
 LCDData = D_ : gosub PCFLCD_Put
 pause 50
 gosub PCFLCD_Clear
 
 j=0'Tabellenoffset
 gosub PCFLCD_Print
 LCDData = Line2 : gosub PCFLCD_CMD
 j=17'Tabellenoffset
 gosub PCFLCD_Print
 
 #loop
  LCDData = Line2+12 : gosub PCFLCD_CMD
  zahl=second : gosub PCFLCD_Zahl2
  pause 10
 goto loop
 
end

'---------------------------------------
' Trick, um die Table-Funktion fr Festtexte zu "mibrauchen"
' max. 256 Byte (128 -1 Zeichen) pro Tabelle
' jedes print bentigt selbst ein Byte !
' Achtung ! Hoch experimentel !
table LCDtext
tabend
print "C C T o o l s   -   P C F L C D ";
print "0 6 . 1 0 . 2 0 0 4 ";


'---------------------------------------
' PCF-LCD-Routinen (fr PCF-LCD-Interface & I2C-Terminal
'---------------------------------------
#PCFLCD_init 'Initialisieren des Displays
 data = PCFLCD : gosub i2c_start
 'Function Set 8 Bit
 data = &h30 : databit3 = LCDLight : gosub i2c_write
 data = &h34 : databit3 = LCDLight : gosub i2c_write
 data = &h30 : databit3 = LCDLight : gosub i2c_write
 pause 1
 data = &h34 : databit3 = LCDLight : gosub i2c_write
 data = &h30 : databit3 = LCDLight : gosub i2c_write
 data = &h34 : databit3 = LCDLight : gosub i2c_write
 data = &h30 : databit3 = LCDLight : gosub i2c_write
 ' Function Set 4 Bit
 data = &h24 : databit3 = LCDLight : gosub i2c_write
 data = &h20 : databit3 = LCDLight : gosub i2c_write

 LCDData = &h28 : gosub PCFLCD_CMD 'Function Set, 2 Zeilen, 5x7 Punkte
 LCDData = &h0C : gosub PCFLCD_CMD 'Cursor Off, display On
 LCDData = &h01 : gosub PCFLCD_CMD
 pause 1
 LCDData = &h06 : gosub PCFLCD_CMD 'Entry-Mode; inkrement, Cursor-shift
goto i2c_stop

#PCFLCD_Clear 'Lschen des Displayinhalts
 LCDData= &h01 :gosub PCFLCD_CMD
 pause 1
return
 
#PCFLCD_CMD ' Kommandobyte senden
 data = PCFLCD : gosub i2c_start
 data = (LCDData and &hF0) or &h4 : databit3 = LCDLight : gosub i2c_write 'Entry-Mode
 data =  LCDData and &hF0         : databit3 = LCDLight : gosub i2c_write
 data = (LCDData shl 4) or &h4    : databit3 = LCDLight : gosub i2c_write ' inkrement, Cursor-shift
 data =  LCDData shl 4            : databit3 = LCDLight : gosub i2c_write
goto i2c_stop
 
#PCFLCD_PUT 'Zeichen senden
 data = PCFLCD : gosub i2c_start
 gosub PCFLCD_SubPut
goto i2c_stop

#PCFLCD_Print ' Zeichenfolge ausgeben.
 data = PCFLCD : gosub i2c_start
 looktab LCDtext,j,LCDData
 #Print_Loop
  gosub PCFLCD_SubPut
  j=j+1
  looktab LCDtext,j,LCDData
 if LCDData<>0 then goto Print_Loop
goto i2c_stop

#PCFLCD_SubPut
 data = (LCDData and &hF0) or &h5 : databit3 = LCDLight : gosub i2c_write 
 data = (LCDData and &hF0) or &h1 : databit3 = LCDLight : gosub i2c_write
 data = (LCDData shl 4) or &h5    : databit3 = LCDLight : gosub i2c_write
 data = (LCDData shl 4) or &h1    : databit3 = LCDLight : gosub i2c_write
return

#PCFLCD_Zahl1 '1 stellige Zahl ausgeben
 data = PCFLCD : gosub i2c_start
 goto PCFLCD_SubZahl1
#PCFLCD_Zahl2 ' 2 stellige Zahl ausgeben
 data = PCFLCD : gosub i2c_start
 goto PCFLCD_SubZahl2
#PCFLCD_Zahl
 data = PCFLCD : gosub i2c_start
 if zahl>99 then LCDData=(zahl/100)+&h30 else LCDData=SPACE
 gosub PCFLCD_SubPut
#PCFLCD_SubZahl2 ' 2 stellige Zahl ausgeben
 if zahl> 9 then LCDData=((zahl/10) mod 10)+&h30 else LCDData=SPACE
 gosub PCFLCD_SubPut
#PCFLCD_SubZahl1 '1 stellige Zahl ausgeben
 LCDData=(zahl mod 10)+&h30
 gosub PCFLCD_SubPut
goto i2c_stop

'---------------------------------------
'IC-Bus-Routinen
'---------------------------------------
'---------------------------------------
#i2c_stop
'---------------------------------------
 SDA = 0
 DEACT SCL
 DEACT SDA
return

'---------------------------------------
#i2c_start 'returns Ack in i
'---------------------------------------
 SDA = 1
 SCL = 1
 SDA = 0
 SCL = 0
'---------------------------------------
#i2c_write 'returns Ack in i
'---------------------------------------
 SDA = data AND &h80
 TOG SCL
 TOG SCL
 for i=1 to 8
  SDA = data AND (&h80 SHR i)
  TOG SCL
  TOG SCL
 next
 DEACT SDA
 TOG SCL
 i = NOT SDA ' Zeile kann zur Erhhung der geschwindigkeit auskommentiert werden
 TOG SCL
return

'---------------------------------------
#i2c_read 'returns Databyte in data
'---------------------------------------
 gosub i2c_sub_read
 SDA = 0
 TOG SCL
 TOG SCL
return

'---------------------------------------
#i2c_readlast 'returns Databyte in data
'---------------------------------------
 gosub i2c_sub_read
 TOG SCL
 TOG SCL
return

#i2c_sub_read
 DEACT SDA
 data = 0
 for i=0 to 8
  TOG SCL
  data = (data shl 1) or (SDA and 1)
  TOG SCL
 next
return

